#!/usr/bin/env python
# -*- coding: utf8 -*-

# Install routine for CatGrab with Python version:
pythonversion = 2.5


import shutil
import os
import sys
import time


print ''
print 'Welcome to CatGrab Installation routine.'
print 'Pleas wait a moment while installation is performing.'
print ''

if sys.platform.find('linux') == -1:
	print '-> Exit! Unknown or unsupported platform.'
	sys.exit()

def path_create(pfad):
	"""Ersellt Pfad recursiv falls nicht vorhanden
	
	Erstellungsdatum: 10.07.2006
	"""
	if os.path.isdir(pfad):
		pass		
	else:
		try:
			os.makedirs(pfad, 0700)
		except:
			return 'ERROR'

def wait():
	NUM = 0 ; POINTS = '...' ; POINT = '...'
	while 1:
		print 'please wait ' + POINT
		NUM += 1
		POINT = POINT + POINTS
		time.sleep(2)
		if NUM == 6:
			print ''
			print ''
			break

##____________________________________________________________Linux istallation

pvers = str(sys.version_info[0]) + '.' +  str(sys.version_info[1])

if pvers == str(pythonversion):
	print 'Python in Version '+pvers+' in use => OK'
	
	if not 'python' + pvers in os.listdir('/usr/bin/'):
		print 'Setup exit - No symlink in "/usr/bin"! Please create a link from Python '+ pvers +' to: /usr/bin/ (/usr/bin/python' + pvers +')'
		sys.exit()

if 'python' + pvers in os.listdir('/usr/bin/'):
	print 'Python '+ pvers +' is found in /usr/bin => OK'
else:
	print ' Setup exit! Install the Python version described in the Manual. If python'+ pvers +' is allready on your system then a link it to: /usr/bin/ ' '(/usr/bin/python' + pvers +')'
	sys.exit()

try:
	import Tkinter
except:
	print 'Installation failed! Please install Tkinter (python-tk) first!'
	sys.exit()

print 'Tkinter available => OK'
	
info = ''

try:
	desktop = os.environ['HOME'] + '/Desktop/'
	desktop = os.path.normpath(desktop)
except:
	try:
		desktop = os.path.expanduser("~") + '/Desktop/'
		desktop = os.path.normpath(desktop)
	except:
		info = info + 'Notice: It was not possibe to dedect the home directory. '

print 'Home directory dedected => OK'

# gehe ins catgrab Verzeichnis
os.chdir('../..')
root = os.getcwd()

# Pfade
target_1 = '/usr/local/catgrab/'
target_2 = '/usr/local/catgrab/doc/'

target_4 = '/usr/bin/catgrab-conf'
target_5 = '/usr/bin/catgrab'

target_6 = '/usr/local/catgrab/su/'
target_7 = '/usr/local/catgrab/prg/bin/'



# Kopiere Dateien in Ziel
try:
	path_create(target_1)
except:
	pass

try:
	shutil.copytree(os.path.normpath(root + '/dat/'), target_1)
except:
	try:
		shutil.rmtree(os.path.normpath(target_1))
		
		shutil.copytree(os.path.normpath(root + '/dat/'), target_1)
	except:
		print ''
		print 'Installation failed! Right problems: Could not create data. Please install with root privilegs. Please type: sudo ./INSTALL_LINUX'
		sys.exit()

try:
	shutil.rmtree(os.path.normpath(target_6))
except:
	pass

print 'Data created => OK'

#create links in /usr/bin
try:
	os.symlink(target_7 + 'catlx.py', '/usr/bin/catgrab')
	os.symlink(target_7 + 'catlx_conf.py', '/usr/bin/catgrab-conf')
	print 'Symlinks created in /usr/bin => OK'
except:
	try:
		os.remove('/usr/bin/catgrab')
		os.remove('/usr/bin/catgrab-conf')
		os.symlink(target_7 + 'catlx.py', '/usr/bin/catgrab')
		os.symlink(target_7 + 'catlx_conf.py', '/usr/bin/catgrab-conf')
		print 'symlinks created in /usr/bin => OK'
	except:
		info = info + 'It was not possibe to create symlinks in /usr/bin. '

#chmod
try:
	os.chmod(target_7 + 'catlx.py', 493)
	os.chmod(target_7 + 'catlx_conf.py', 493)		
	
	os.chmod(target_1, 493)
	os.chmod(target_2, 493)
	
	os.chmod(target_4, 493)
	os.chmod(target_5, 493)
except:
	print ''
	print 'Notice: It was not possibe to create data with proper rights. Maybe this ist the wrong OS or the installation data ist corupted '
	sys.exit()

print 'Data rights => OK'
	
#starter in menu 
try:
	if os.path.isdir('/usr/local/share/applications/'):
		shutil.copy(os.path.normpath(target_1 + '/misc/lx/CatGrab.desktop'), '/usr/local/share/applications/')
		shutil.copy(os.path.normpath(target_1 + '/misc/lx/CatGrab-Conf.desktop'), '/usr/local/share/applications/')
	elif os.path.isdir('/usr/share/applications/'):
		shutil.copy(os.path.normpath(target_1 + '/misc/lx/CatGrab.desktop'), '/usr/share/applications/')
		shutil.copy(os.path.normpath(target_1 + '/misc/lx/CatGrab-Conf.desktop'), '/usr/share/applications/')
	else:
		pass
	
	# meldung während menüaktualisierung
	if os.path.isfile('/usr/bin/update-menus'):
		os.system('update-menus')
		wait()
	
	info = info + 'CatGrab can now be started using the console (with: catgrab or catgrab­conf) or using the start button in the start menu (in the graphic menu item).'
except:
	info = info + 'CatGrab can now be started using the console (with: catgrab or catgrab­conf).'


extra = ''
if info is not '':
	extra = 'Additional Information: ' + info

# mitteilung an user
print ''
print 'Programm is sucsessfully installed! \n' + extra


sys.exit()
